## com.saxonica.codegen
Class RootFunctionCompiler

    java.lang.Object
      com.saxonica.codegen.ExpressionCompiler
          com.saxonica.codegen.SingletonExpressionCompiler
              com.saxonica.codegen.RootFunctionCompiler

    public class RootFunctionCompiler

extends SingletonExpressionCompiler

Generate Java code to implement the expression "root()"

Constructor Summary
`RootFunctionCompiler()`

Method Summary
`void` `compilePush(CompilerService compiler, Expression expr)` Generate Java code to execute the expression in push mode, that is, code to write events to the current output Receiver
`java.lang.String` `compileToItem(CompilerService compiler, Expression expr)` Generate Java code to evaluate the expression as an Item
`java.lang.String` `compileToIterator(CompilerService compiler, Expression expr)` Generate Java code to evaluate the expression as a SequenceIterator

Methods inherited from class com.saxonica.codegen.SingletonExpressionCompiler
`compileToCharSequence, compileToEffectiveBooleanValue`

Methods inherited from class com.saxonica.codegen.ExpressionCompiler
`compileAsLoop, compileToValueRepresentation`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RootFunctionCompiler

    public RootFunctionCompiler()

Method Detail

### compilePush

    public void compilePush(CompilerService compiler,
                            Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to execute the expression in push mode, that is, code to write events to the current output Receiver

  Overrides:
    `compilePush` in class `SingletonExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the expression to be compiled

### compileToIterator

    public java.lang.String compileToIterator(CompilerService compiler,
                                              Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as a SequenceIterator

  Overrides:
    `compileToIterator` in class `SingletonExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the XPath expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared) which will be of class `SequenceIterator`, and which at run-time will hold an iterator over the the value of the XPath expression

### compileToItem

    public java.lang.String compileToItem(CompilerService compiler,
                                          Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as an Item

  Specified by:
    `compileToItem` in class `ExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared) which will be of class `Item`, and which will hold the value of the expression at run-time (or hold null, representing an empty sequence).

Copyright (c) Saxonica Limited. All rights reserved.